C
C Matrix - Vektor Multiplikation (Standard-Optimiert)
C
      PROGRAM Example4c
      IMPLICIT NONE

      INTEGER PAR_DIM
      PARAMETER( PAR_DIM = 3000 )

      DOUBLE PRECISION Matrix_A( PAR_DIM , PAR_DIM )      
      DOUBLE PRECISION Feld_B( PAR_DIM )      
      DOUBLE PRECISION Feld_C( PAR_DIM )      
      DOUBLE PRECISION S

      INTEGER N , M , I , J , K , K_IT , Loop
      INTEGER VECL , VEC_LOOP , VEC_REST
      INTEGER VECS_1 , SHIFT_1 , VECS_2 ,  SHIFT_2
      

C
C Beispiel 1
C
      N = 3000
      M = N
      K_IT = 200

C
C Beispiel 2
C
c      write(*,*) " N "
c      read(*,*) N 
c      M = N
c      K_IT = 200

      DO J = 1 , M 
         DO I = 1 , N
            Matrix_A(I,J)   = dble( I*J )
         ENDDO
      ENDDO
      DO I = 1 , N
         Feld_B(I)   = 0.d0
      ENDDO
      DO J = 1 , N
         Feld_C(J)   = 1.d0/j
      ENDDO

      VECL = 2048

      DO Loop = 1 , K_IT  
C
C
C
         IF(N.le.2048) THEN
            
            DO J = 1 , M

               DO I = 1 , N

                  Feld_B( I ) = Feld_B( I ) + Matrix_A(I,J) * Feld_C(J)
                  
               ENDDO
            
            ENDDO
            
         ELSE
            
            VEC_LOOP = N / VECL
            VEC_REST = (VEC_LOOP * VECL) + 1

            DO VECS_1 = 1 , VEC_LOOP
               SHIFT_1 = (VECS_1 - 1) * VECL

               DO VECS_2 = 1 , VEC_LOOP
                  SHIFT_2 = (VECS_2 - 1) * VECL

                  DO J = 1 , VECL

                     DO I = 1 , VECL

                        Feld_B( I+SHIFT_1 ) = Feld_B( I+SHIFT_1 ) 
     $                       + Matrix_A(I+SHIFT_1,J+SHIFT_2) 
     $                       * Feld_C(J+SHIFT_2)
                  
                     ENDDO
            
                  ENDDO
                  
               ENDDO
               
            ENDDO

            DO VECS_1 = 1 , VEC_LOOP
               SHIFT_1 = (VECS_1 - 1) * VECL

               DO J = VEC_REST , N

                  DO I = 1 , VECL

                     Feld_B( I+SHIFT_1 ) = Feld_B( I+SHIFT_1 ) 
     $                    + Matrix_A(I+SHIFT_1,J) 
     $                    * Feld_C(J)
                     
                  ENDDO
            
               ENDDO
               
            ENDDO


            DO J = 1 , N

               DO I = VEC_REST , N 

                  Feld_B( I ) = Feld_B( I ) 
     $                 + Matrix_A(I , J) 
     $                 * Feld_C(J)

               ENDDO

            ENDDO

         ENDIF                  ! OF <> 2048
C
C
C
      ENDDO                     ! OF K_IT

      S = 0.d0
      DO I = 1 , N
         S = S + Feld_B( I )
      ENDDO

      
      write(*,*) " N = ",N
      write(*,*) " S = ", S

      END
